
/////////////////////////////////////////////////////////////////////////////
//
//  Screen saver shell  version 0.00 alpha
//  Written by Y [21-12-99]. See note! for details.
//
//  Copyright (c) 1999 CROWELL, Inc. All Rights Reserved.
//
/////////////////////////////////////////////////////////////////////////////

{$R SCRNSAVE.RES}

uses
  Windows, Classes, IniFiles;

procedure AGoGo;
var
  IniFile: TIniFile;
  Executable, CmdLine: String;
  lpStartupInfo: TStartupInfo;
  lpProcessInformation: TProcessInformation;

begin
  IniFile := nil;
  try
    IniFile := TIniFile.Create('SYSTEM.INI');
    Executable := IniFile.ReadString('boot', 'SCRNSAVE.EXE', '');
    if (Executable <> '') then
    begin
      if ParamStr(1) = '/s' then
        CmdLine := 'SCRNSAVE.EXE'
      else
        CmdLine := 'SCRNSAVE.EXE /s';

      with lpStartupInfo do
      begin
        lpReserved := nil;
        lpDesktop := nil;         // inherit
        lpTitle := nil;           // for console processes: use exename as title
        dwFlags := 0;             // don't use certain flags during creation
        cbReserved2 := 0;
        lpReserved2 := nil;
        cb := 64;                 // the size of this structure
      end;

      CreateProcess( 
        PChar(Executable),        // Executable
        PChar(CmdLine),           // Command line
        nil,                      // Process security attributes: default
        nil,                      // Thread security attributes: default
        True,                     // Inherits handles
        CREATE_DEFAULT_ERROR_MODE or REALTIME_PRIORITY_CLASS,
        nil,                      // Default environment is used
        nil,                      // Default current directory
        lpStartupInfo,            // Pointer to startup info
        lpProcessInformation      // Pointer to process nformation
      );
    end;

  except
    if Assigned(IniFile) then
      IniFile.Free;

    MessageBeep(DWORD(-1));
    MessageBox(
      0,
      'Error opening system initialization'#13 +
      'file (SYSTEM.INI).',
      'Error',
      MB_OK or MB_ICONSTOP {MB_ICONEXCLAMATION});
  end;
end;

begin
  if ParamStr(1) = '/?' then
    MessageBox(
      0,
      'Screen saver shell version 0.00 alpha'#13 +
      'Written by Y [21-12-99].'#13#13 +
      'Copyright (c) 1999 CROWELL, Inc.'#13 +
      'All Rights Reserved.',
      'About',
      MB_OK or MB_ICONASTERISK)
  else 
    AGoGo;
end.